with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.IHTMLTable4_Interface is

   procedure Initialize (This : in out IHTMLTable4_Type) is
   begin
      Set_IID (This, IID_IHTMLTable4);
   end Initialize;

   function Pointer (This : IHTMLTable4_Type)
     return Pointer_To_IHTMLTable4
   is
   begin
      return To_Pointer_To_IHTMLTable4 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLTable4_Type;
                     Pointer : in     Pointer_To_IHTMLTable4)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure PutRef_tHead
     (This : IHTMLTable4_Type;
      p    : Pointer_To_IHTMLTableSection)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.PutRef_tHead
         (Pointer (This),
          p));

   end PutRef_tHead;

   function Get_tHead
     (This : IHTMLTable4_Type)
     return Pointer_To_IHTMLTableSection
   is
       RetVal : aliased Pointer_To_IHTMLTableSection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_tHead
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_tHead;

   procedure PutRef_tFoot
     (This : IHTMLTable4_Type;
      p    : Pointer_To_IHTMLTableSection)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.PutRef_tFoot
         (Pointer (This),
          p));

   end PutRef_tFoot;

   function Get_tFoot
     (This : IHTMLTable4_Type)
     return Pointer_To_IHTMLTableSection
   is
       RetVal : aliased Pointer_To_IHTMLTableSection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_tFoot
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_tFoot;

   procedure PutRef_caption
     (This : IHTMLTable4_Type;
      p    : Pointer_To_IHTMLTableCaption)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.PutRef_caption
         (Pointer (This),
          p));

   end PutRef_caption;

   function Get_caption
     (This : IHTMLTable4_Type)
     return Pointer_To_IHTMLTableCaption
   is
       RetVal : aliased Pointer_To_IHTMLTableCaption;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_caption
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_caption;

   function insertRow
     (This  : IHTMLTable4_Type;
      index : Interfaces.C.long)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.insertRow
         (Pointer (This),
          index,
          RetVal'Unchecked_Access));

      return RetVal;
   end insertRow;

   procedure deleteRow
     (This  : IHTMLTable4_Type;
      index : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.deleteRow
         (Pointer (This),
          index));

   end deleteRow;

   function createTBody
     (This  : IHTMLTable4_Type)
     return Pointer_To_IHTMLTableSection
   is
       RetVal : aliased Pointer_To_IHTMLTableSection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.createTBody
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end createTBody;

end MSHTML.IHTMLTable4_Interface;

